Index: moodle/backup/util/ui/base_moodleform.class.php
--- moodle/backup/util/ui/base_moodleform.class.php No Base Revision
+++ moodle/backup/util/ui/base_moodleform.class.php Locally New
@@ -0,0 +1,260 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains the generic moodleform bridge for the backup user interface
+ * as well as the individual forms that relate to the different stages the user
+ * interface can exist within.
+ *
+ * @package   moodlecore
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+require_once($CFG->libdir . '/formslib.php');
+
+/**
+ * Backup moodleform bridge
+ *
+ * Ahhh the mighty moodleform bridge! Strong enough to take the weight of 682 full
+ * grown african swallows all of whom have been carring coconuts for several days.
+ * EWWWWW!!!!!!!!!!!!!!!!!!!!!!!!
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+abstract class base_moodleform extends moodleform {
+    /**
+     * The stage this form belongs to
+     * @var base_ui_stage
+     */
+    protected $uistage = null;
+    /**
+     * True if we have a course div open, false otherwise
+     * @var bool
+     */
+    protected $coursediv = false;
+    /**
+     * True if we have a section div open, false otherwise
+     * @var bool
+     */
+    protected $sectiondiv = false;
+    /**
+     * True if we have an activity div open, false otherwise
+     * @var bool
+     */
+    protected $activitydiv = false;
+    /**
+     * Creates the form
+     *
+     * @param backup_ui_stage $uistage
+     * @param moodle_url|string $action
+     * @param mixed $customdata
+     * @param string $method get|post
+     * @param string $target
+     * @param array $attributes
+     * @param bool $editable
+     */
+    function __construct(base_ui_stage $uistage, $action=null, $customdata=null, $method='post', $target='', $attributes=null, $editable=true) {
+        $this->uistage = $uistage;
+        parent::__construct($action, $customdata, $method, $target, $attributes, $editable);
+    }
+    /**
+     * The standard form definition... obviously not much here
+     */
+    function definition() {
+        $ui = $this->uistage->get_ui();
+        $mform = $this->_form;
+        $stage = $mform->addElement('hidden', 'stage', $this->uistage->get_stage());
+        $stage = $mform->addElement('hidden', $ui->get_name(), $ui->get_uniqueid());
+        $params = $this->uistage->get_params();
+        if (is_array($params) && count($params) > 0) {
+            foreach ($params as $name=>$value) {
+                $stage = $mform->addElement('hidden', $name, $value);
+            }
+        }
+    }
+    /**
+     * Definition applied after the data is organised.. why's it here? because I want
+     * to add elements on the fly.
+     */
+    function definition_after_data() {
+        $buttonarray=array();
+        if (!$this->uistage->is_first_stage()) {
+            $buttonarray[] = $this->_form->createElement('submit', 'previous', get_string('previousstage','backup'));
+        }
+        $buttonarray[] = $this->_form->createElement('submit', 'submitbutton', get_string($this->uistage->get_ui()->get_name().'stage'.$this->uistage->get_stage().'action', 'backup'));
+        $buttonarray[] = $this->_form->createElement('cancel');
+        $this->_form->addGroup($buttonarray, 'buttonar', '', array(' '), false);
+        $this->_form->closeHeaderBefore('buttonar');
+    }
+    /**
+     * Closes any open divs
+     */
+    function close_task_divs() {
+        if ($this->activitydiv) {
+            $this->_form->addElement('html', html_writer::end_tag('div'));
+            $this->activitydiv = false;
+        }
+        if ($this->sectiondiv) {
+            $this->_form->addElement('html', html_writer::end_tag('div'));
+            $this->sectiondiv = false;
+        }
+        if ($this->coursediv) {
+            $this->_form->addElement('html', html_writer::end_tag('div'));
+            $this->coursediv = false;
+        }
+    }
+    /**
+     * Adds the backup_setting as a element to the form
+     * @param backup_setting $setting
+     * @return bool
+     */
+    function add_setting(backup_setting $setting, base_task $task=null) {
+
+        // If the setting cant be changed then add it as a fixed setting.
+        if (!$setting->get_ui()->is_changeable()) {
+            return $this->add_fixed_setting($setting);
+        }
+
+        // First add the formatting for this setting
+        $this->add_html_formatting($setting);
+
+        // The call the add method with the get_element_properties array
+        call_user_method_array('addElement', $this->_form, $setting->get_ui()->get_element_properties($task));
+        $this->_form->setDefault($setting->get_ui_name(), $setting->get_value());
+        if ($setting->has_help()) {
+            list($identifier, $component) = $setting->get_help();
+            $this->_form->addHelpButton($setting->get_ui_name(), $identifier, $component);
+        }
+        $this->_form->addElement('html', html_writer::end_tag('div'));
+        return true;
+    }
+    /**
+     * Adds a heading to the form
+     * @param string $name
+     * @param string $text
+     */
+    function add_heading($name , $text) {
+        $this->_form->addElement('header', $name, $text);
+    }
+    /**
+     * Adds HTML formatting for the given backup setting, needed to group/segment
+     * correctly.
+     * @param backup_setting $setting
+     */
+    protected function add_html_formatting(backup_setting $setting) {
+        $mform = $this->_form;
+        $isincludesetting = (strpos($setting->get_name(), '_include')!==false);
+        if ($isincludesetting && $setting->get_level() != backup_setting::ROOT_LEVEL)  {
+            switch ($setting->get_level()) {
+                case backup_setting::COURSE_LEVEL:
+                    if ($this->activitydiv) {
+                        $this->_form->addElement('html', html_writer::end_tag('div'));
+                        $this->activitydiv = false;
+                    }
+                    if ($this->sectiondiv) {
+                        $this->_form->addElement('html', html_writer::end_tag('div'));
+                        $this->sectiondiv = false;
+                    }
+                    if ($this->coursediv) {
+                        $this->_form->addElement('html', html_writer::end_tag('div'));
+                    }
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'grouped_settings course_level')));
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'include_setting course_level')));
+                    $this->coursediv = true;
+                    break;
+                case backup_setting::SECTION_LEVEL:
+                    if ($this->activitydiv) {
+                        $this->_form->addElement('html', html_writer::end_tag('div'));
+                        $this->activitydiv = false;
+                    }
+                    if ($this->sectiondiv) {
+                        $this->_form->addElement('html', html_writer::end_tag('div'));
+                    }
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'grouped_settings section_level')));
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'include_setting section_level')));
+                    $this->sectiondiv = true;
+                    break;
+                case backup_setting::ACTIVITY_LEVEL:
+                    if ($this->activitydiv) {
+                        $this->_form->addElement('html', html_writer::end_tag('div'));
+                    }
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'grouped_settings activity_level')));
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'include_setting activity_level')));
+                    $this->activitydiv = true;
+                    break;
+                default:
+                    $mform->addElement('html', html_writer::start_tag('div', array('class'=>'normal_setting')));
+                    break;
+            }
+        } else if ($setting->get_level() == backup_setting::ROOT_LEVEL) {
+            $mform->addElement('html', html_writer::start_tag('div', array('class'=>'root_setting')));
+        } else {
+            $mform->addElement('html', html_writer::start_tag('div', array('class'=>'normal_setting')));
+        }
+    }
+    /**
+     * Adds a fixed or static setting to the form
+     * @param backup_setting $setting
+     */
+    function add_fixed_setting(backup_setting $setting) {
+        global $OUTPUT;
+        $settingui = $setting->get_ui();
+        if ($setting->get_visibility() == backup_setting::VISIBLE) {
+            $this->add_html_formatting($setting);
+            switch ($setting->get_status()) {
+                case backup_setting::LOCKED_BY_PERMISSION:
+                    $icon = ' '.$OUTPUT->pix_icon('i/permissionlock', get_string('lockedbypermission', 'backup'), 'moodle', array('class'=>'smallicon lockedicon permissionlock'));
+                    break;
+                case backup_setting::LOCKED_BY_CONFIG:
+                    $icon = ' '.$OUTPUT->pix_icon('i/configlock', get_string('lockedbyconfig', 'backup'), 'moodle', array('class'=>'smallicon lockedicon configlock'));
+                    break;
+                case backup_setting::LOCKED_BY_HIERARCHY:
+                    $icon = ' '.$OUTPUT->pix_icon('i/hierarchylock', get_string('lockedbyhierarchy', 'backup'), 'moodle', array('class'=>'smallicon lockedicon configlock'));
+                    break;
+                default:
+                    $icon = '';
+                    break;
+            }
+            $this->_form->addElement('static', 'static_'.$settingui->get_name(), $settingui->get_label(), $settingui->get_static_value().$icon);
+            $this->_form->addElement('html', html_writer::end_tag('div'));
+        }
+        $this->_form->addElement('hidden', $settingui->get_name(), $settingui->get_value());
+    }
+    /**
+     * Adds dependencies to the form recursively
+     *
+     * @param backup_setting $setting
+     */
+    function add_dependencies(backup_setting $setting) {
+        $mform = $this->_form;
+        // Apply all dependencies for backup
+        foreach ($setting->get_my_dependency_properties() as $key=>$dependency) {
+            call_user_method_array('disabledIf', $this->_form, $dependency);
+        }
+    }
+    /**
+     * Returns true if the form was cancelled, false otherwise
+     * @return bool
+     */
+    public function is_cancelled() {
+        return (optional_param('cancel', false, PARAM_BOOL) || parent::is_cancelled());
+    }
+}
\ No newline at end of file
Index: moodle/backup/util/ui/base_ui.class.php
--- moodle/backup/util/ui/base_ui.class.php No Base Revision
+++ moodle/backup/util/ui/base_ui.class.php Locally New
@@ -0,0 +1,281 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains the backup user interface class
+ *
+ * @package   moodlecore
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * This is the backup user interface class
+ *
+ * The backup user interface class manages the user interface and backup for
+ * Moodle.
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+abstract class base_ui {
+    /**
+     * The progress of this instance of the backup ui class
+     */
+    const PROGRESS_INTIAL = 0;
+    const PROGRESS_PROCESSED = 1;
+    const PROGRESS_SAVED = 2;
+    const PROGRESS_EXECUTED = 3;
+    /**
+     * The controller
+     * @var backup_controller|restore_controller
+     */
+    protected $controller;
+    /**
+     * The current stage
+     * @var base_ui_stage
+     */
+    protected $stage;
+    /**
+     * The current progress of the UI
+     * @var int One of self::PROGRESS_*
+     */
+    protected $progress;
+    /**
+     * The number of changes made by dependency enforcement
+     * @var int
+     */
+    protected $dependencychanges = 0;
+
+    /**
+     * Yay for constructors
+     * @param backup_controller $controller
+     */
+    public function __construct($controller, array $params=null) {
+        $this->controller = $controller;
+        $this->progress = self::PROGRESS_INTIAL;
+        $this->stage = $this->initialise_stage(null, $params);
+        // Process UI event before to be safe
+        $this->controller->process_ui_event();
+    }
+    /**
+     * Intialises what ever stage is requested. If none are requested we check
+     * params for 'stage' and default to initial
+     *
+     * @param int|null $stage The desired stage to intialise or null for the default
+     * @return base_ui_stage
+     */
+    abstract protected function initialise_stage($stage = null, array $params=null);
+    /**
+     * This processes the current stage of the backup
+     * @return bool
+     */
+    public function process() {
+        if ($this->progress >= self::PROGRESS_PROCESSED) {
+            throw new backup_ui_exception('backupuialreadyprocessed');
+        }
+        $this->progress = self::PROGRESS_PROCESSED;
+
+        if (optional_param('previous', false, PARAM_BOOL) && $this->stage->get_stage() > self::STAGE_INITIAL) {
+            $this->stage = $this->initialise_stage($this->stage->get_prev_stage(), $this->stage->get_params());
+            return false;
+        }
+
+        // Process the stage
+        $processoutcome = $this->stage->process();
+
+        if ($processoutcome !== false) {
+            $this->stage = $this->initialise_stage($this->stage->get_next_stage(), $this->stage->get_params());
+        }
+
+        // Process UI event after to check changes are valid
+        $this->controller->process_ui_event();
+        return $processoutcome;
+    }
+    /**
+     * Saves the backup controller.
+     *
+     * Once this has been called nothing else can be changed in the controller.
+     *
+     * @return bool
+     */
+    public function save_controller() {
+        if ($this->progress >= self::PROGRESS_SAVED) {
+            throw new base_ui_exception('backupuialreadysaved');
+        }
+        $this->progress = self::PROGRESS_SAVED;
+        // First enforce dependencies
+        $this->enforce_dependencies();
+        // Process UI event after to check any changes are valid
+        $this->controller->process_ui_event();
+        // Save the controller
+        $this->controller->save_controller();
+        return true;
+    }
+    /**
+     * Displays the UI for the backup!
+     *
+     * Note: The UI makes use of mforms (ewww!) thus it will automatically print
+     * out the result rather than returning a string of HTML like other parts of Moodle
+     *
+     * @return bool
+     */
+    public function display() {
+        if ($this->progress < self::PROGRESS_SAVED) {
+            throw new base_ui_exception('backupsavebeforedisplay');
+        }
+        $this->stage->display();
+    }
+    /**
+     * Gets all backup tasks from the controller
+     * @return array Array of backup_task
+     */
+    public function get_tasks() {
+        $plan = $this->controller->get_plan();
+        $tasks = $plan->get_tasks();
+        return $tasks;
+    }
+    /**
+     * Gets the stage we are on
+     * @return int
+     */
+    public function get_stage() {
+        return $this->stage->get_stage();
+    }
+    /**
+     * Gets the name of the stage we are on
+     * @return string
+     */
+    public function get_stage_name() {
+        return $this->stage->get_name();
+    }
+    /**
+     * Gets the backup id from the controller
+     * @return string
+     */
+    abstract public function get_uniqueid();
+    /**
+     * Executes the backup plan
+     * @return bool
+     */
+    abstract public function execute();
+    /**
+     * Enforces dependencies on all settings. Call before save
+     * @return bool True if dependencies were enforced and changes were made
+     */
+    protected function enforce_dependencies() {
+        // Get the plan
+        $plan = $this->controller->get_plan();
+        // Get the tasks as a var so we can iterate by reference
+        $tasks = $plan->get_tasks();
+        $changes = 0;
+        foreach ($tasks as &$task) {
+            // Store as a var so we can iterate by reference
+            $settings = $task->get_settings();
+            foreach ($settings as &$setting) {
+                // Get all dependencies for iteration by reference
+                $dependencies = $setting->get_dependencies();
+                foreach ($dependencies as &$dependency) {
+                    // Enforce each dependency
+                    if ($dependency->enforce()) {
+                        $changes++;
+                    }
+                }
+            }
+        }
+        // Store the number of settings that changed through enforcement
+        $this->dependencychanges = $changes;
+        return ($changes>0);
+    }
+    /**
+     * Returns true if enforce_dependencies changed any settings
+     * @return bool
+     */
+    public function enforce_changed_dependencies() {
+        return ($this->dependencychanges > 0);
+    }
+    /**
+     * Loads the backup controller if we are tracking one
+     * @return backup_controller|false
+     */
+    abstract public static function load_controller($uniqueid=false);
+    /**
+     * Gets an array of progress bar items that can be displayed through the backup renderer.
+     * @return array Array of items for the progress bar
+     */
+    abstract public function get_progress_bar();
+    /**
+     * Gets the format for the backup
+     * @return int
+     */
+    public function get_format() {
+        return $this->controller->get_format();
+    }
+    /**
+     * Gets the type of the backup
+     * @return int
+     */
+    public function get_type() {
+        return $this->controller->get_type();
+    }
+    public function get_controller() {
+        return $this->controller;
+    }
+    /**
+     * Gets the ID used in creating the controller. Relates to course/section/cm
+     * @return int
+     */
+    public function get_controller_id() {
+        return $this->controller->get_id();
+    }
+    /**
+     * Gets the requested setting
+     * @param string $name
+     * @return mixed
+     */
+    public function get_setting($name, $default = false) {
+        try {
+            return $this->controller->get_plan()->get_setting($name);
+        } catch (Exception $e) {
+            debugging('Failed to find the setting: '.$name, DEBUG_DEVELOPER);
+            return $default;
+        }
+    }
+    /**
+     * Gets the value for the requested setting
+     *
+     * @param string $name
+     * @return mixed
+     */
+    public function get_setting_value($name, $default = false) {
+        try {
+            return $this->controller->get_plan()->get_setting($name)->get_value();
+        } catch (Exception $e) {
+            debugging('Failed to find the setting: '.$name, DEBUG_DEVELOPER);
+            return $default;
+        }
+    }
+
+    abstract public function get_name();
+
+    abstract public function get_first_stage_id();
+}
+
+/**
+ * Backup user interface exception. Modelled off the backup_exception class
+ */
+class base_ui_exception extends backup_exception {}
\ No newline at end of file
Index: moodle/backup/util/ui/base_ui_stage.class.php
--- moodle/backup/util/ui/base_ui_stage.class.php No Base Revision
+++ moodle/backup/util/ui/base_ui_stage.class.php Locally New
@@ -0,0 +1,147 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Backup user interface stages
+ *
+ * This file contains the classes required to manage the stages that make up the
+ * backup user interface.
+ * These will be primarily operated a {@see backup_ui} instance.
+ *
+ * @package   moodlecore
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Abstract stage class
+ *
+ * This class should be extended by all backup stages (a requirement of many backup ui functions).
+ * Each stage must then define two abstract methods
+ *  - process : To process the stage
+ *  - initialise_stage_form : To get a backup_moodleform instance for the stage
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+abstract class base_ui_stage {
+    /**
+     * The current stage
+     * @var int
+     */
+    protected $stage = 1;
+    /**
+     * The backuck UI object
+     * @var base_ui
+     */
+    protected $ui;
+    /**
+     * The moodleform for this stage
+     * @var base_moodleform
+     */
+    protected $stageform = null;
+    /**
+     * Custom form params that will be added as hidden inputs
+     */
+    protected $params = null;
+    /**
+     *
+     * @param base_ui $ui
+     */
+    public function __construct(base_ui $ui, array $params=null) {
+        $this->ui = $ui;
+        $this->params = $params;
+    }
+    /**
+     * Returns the custom params for this stage
+     * @return array|null
+     */
+    final public function get_params() {
+        return $this->params;
+    }
+    /**
+     * The current stage
+     * @return int
+     */
+    final public function get_stage() {
+        return $this->stage;
+    }
+    /**
+     * The next stage
+     * @return int
+     */
+    final public function get_next_stage() {
+        return floor($this->stage*2);
+    }
+    /**
+     * The previous stage
+     * @return int
+     */
+    final public function get_prev_stage() {
+        return floor($this->stage/2);
+    }
+    /**
+     * The name of this stage
+     * @return string
+     */
+    public function get_name() {
+        return get_string('currentstage'.$this->stage,'backup');
+    }
+    /**
+     * The backup id from the backup controller
+     * @return string
+     */
+    final public function get_uniqueid() {
+        return $this->ui->get_uniqueid();
+    }
+    /**
+     * Displays the stage.
+     *
+     * By default this involves instantiating the form for the stage and the calling
+     * it to display. Remember this is a moodleform instance so it will print
+     * rather than return.
+     */
+    public function display() {
+        $form = $this->initialise_stage_form();
+        $form->display();
+    }
+    /**
+     * Processes the stage.
+     *
+     * This must be overridden by every stage as it will be different for every stage
+     *
+     * @abstract
+     * @param backup_moodleform|null $form
+     */
+    abstract public function process(base_moodleform $form=null);
+    /**
+     * Creates an instance of the correct moodleform properly populated and all
+     * dependencies instantiated
+     *
+     * @abstract
+     * @return backup_moodleform
+     */
+    abstract protected function initialise_stage_form();
+
+    final public function get_ui() {
+        return $this->ui;
+    }
+
+    final public function is_first_stage() {
+        return $this->stage == 1;
+    }
+}
\ No newline at end of file
